<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/gimli-0.26.2/src/read/mod.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>mod.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../gimli/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../gimli/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../gimli/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
<span id="470">470</span>
<span id="471">471</span>
<span id="472">472</span>
<span id="473">473</span>
<span id="474">474</span>
<span id="475">475</span>
<span id="476">476</span>
<span id="477">477</span>
<span id="478">478</span>
<span id="479">479</span>
<span id="480">480</span>
<span id="481">481</span>
<span id="482">482</span>
<span id="483">483</span>
<span id="484">484</span>
<span id="485">485</span>
<span id="486">486</span>
<span id="487">487</span>
<span id="488">488</span>
<span id="489">489</span>
<span id="490">490</span>
<span id="491">491</span>
<span id="492">492</span>
<span id="493">493</span>
<span id="494">494</span>
<span id="495">495</span>
<span id="496">496</span>
<span id="497">497</span>
<span id="498">498</span>
<span id="499">499</span>
<span id="500">500</span>
<span id="501">501</span>
<span id="502">502</span>
<span id="503">503</span>
<span id="504">504</span>
<span id="505">505</span>
<span id="506">506</span>
<span id="507">507</span>
<span id="508">508</span>
<span id="509">509</span>
<span id="510">510</span>
<span id="511">511</span>
<span id="512">512</span>
<span id="513">513</span>
<span id="514">514</span>
<span id="515">515</span>
<span id="516">516</span>
<span id="517">517</span>
<span id="518">518</span>
<span id="519">519</span>
<span id="520">520</span>
<span id="521">521</span>
<span id="522">522</span>
<span id="523">523</span>
<span id="524">524</span>
<span id="525">525</span>
<span id="526">526</span>
<span id="527">527</span>
<span id="528">528</span>
<span id="529">529</span>
<span id="530">530</span>
<span id="531">531</span>
<span id="532">532</span>
<span id="533">533</span>
<span id="534">534</span>
<span id="535">535</span>
<span id="536">536</span>
<span id="537">537</span>
<span id="538">538</span>
<span id="539">539</span>
<span id="540">540</span>
<span id="541">541</span>
<span id="542">542</span>
<span id="543">543</span>
<span id="544">544</span>
<span id="545">545</span>
<span id="546">546</span>
<span id="547">547</span>
<span id="548">548</span>
<span id="549">549</span>
<span id="550">550</span>
<span id="551">551</span>
<span id="552">552</span>
<span id="553">553</span>
<span id="554">554</span>
<span id="555">555</span>
<span id="556">556</span>
<span id="557">557</span>
<span id="558">558</span>
<span id="559">559</span>
<span id="560">560</span>
<span id="561">561</span>
<span id="562">562</span>
<span id="563">563</span>
<span id="564">564</span>
<span id="565">565</span>
<span id="566">566</span>
<span id="567">567</span>
<span id="568">568</span>
<span id="569">569</span>
<span id="570">570</span>
<span id="571">571</span>
<span id="572">572</span>
<span id="573">573</span>
<span id="574">574</span>
<span id="575">575</span>
<span id="576">576</span>
<span id="577">577</span>
<span id="578">578</span>
<span id="579">579</span>
<span id="580">580</span>
<span id="581">581</span>
<span id="582">582</span>
<span id="583">583</span>
<span id="584">584</span>
<span id="585">585</span>
<span id="586">586</span>
<span id="587">587</span>
<span id="588">588</span>
<span id="589">589</span>
<span id="590">590</span>
<span id="591">591</span>
<span id="592">592</span>
<span id="593">593</span>
<span id="594">594</span>
<span id="595">595</span>
<span id="596">596</span>
<span id="597">597</span>
<span id="598">598</span>
<span id="599">599</span>
<span id="600">600</span>
<span id="601">601</span>
<span id="602">602</span>
<span id="603">603</span>
<span id="604">604</span>
<span id="605">605</span>
<span id="606">606</span>
<span id="607">607</span>
<span id="608">608</span>
<span id="609">609</span>
<span id="610">610</span>
<span id="611">611</span>
<span id="612">612</span>
<span id="613">613</span>
<span id="614">614</span>
<span id="615">615</span>
<span id="616">616</span>
<span id="617">617</span>
<span id="618">618</span>
<span id="619">619</span>
<span id="620">620</span>
<span id="621">621</span>
<span id="622">622</span>
<span id="623">623</span>
<span id="624">624</span>
<span id="625">625</span>
<span id="626">626</span>
<span id="627">627</span>
<span id="628">628</span>
<span id="629">629</span>
<span id="630">630</span>
<span id="631">631</span>
<span id="632">632</span>
<span id="633">633</span>
<span id="634">634</span>
<span id="635">635</span>
<span id="636">636</span>
<span id="637">637</span>
<span id="638">638</span>
<span id="639">639</span>
<span id="640">640</span>
<span id="641">641</span>
<span id="642">642</span>
<span id="643">643</span>
<span id="644">644</span>
<span id="645">645</span>
<span id="646">646</span>
<span id="647">647</span>
<span id="648">648</span>
<span id="649">649</span>
<span id="650">650</span>
<span id="651">651</span>
<span id="652">652</span>
<span id="653">653</span>
<span id="654">654</span>
<span id="655">655</span>
<span id="656">656</span>
<span id="657">657</span>
<span id="658">658</span>
<span id="659">659</span>
<span id="660">660</span>
<span id="661">661</span>
<span id="662">662</span>
<span id="663">663</span>
<span id="664">664</span>
<span id="665">665</span>
<span id="666">666</span>
<span id="667">667</span>
<span id="668">668</span>
<span id="669">669</span>
<span id="670">670</span>
<span id="671">671</span>
<span id="672">672</span>
<span id="673">673</span>
<span id="674">674</span>
<span id="675">675</span>
<span id="676">676</span>
<span id="677">677</span>
<span id="678">678</span>
<span id="679">679</span>
<span id="680">680</span>
<span id="681">681</span>
<span id="682">682</span>
<span id="683">683</span>
<span id="684">684</span>
<span id="685">685</span>
<span id="686">686</span>
<span id="687">687</span>
<span id="688">688</span>
<span id="689">689</span>
<span id="690">690</span>
<span id="691">691</span>
<span id="692">692</span>
<span id="693">693</span>
<span id="694">694</span>
<span id="695">695</span>
<span id="696">696</span>
<span id="697">697</span>
<span id="698">698</span>
<span id="699">699</span>
<span id="700">700</span>
<span id="701">701</span>
<span id="702">702</span>
<span id="703">703</span>
<span id="704">704</span>
<span id="705">705</span>
<span id="706">706</span>
<span id="707">707</span>
<span id="708">708</span>
<span id="709">709</span>
<span id="710">710</span>
<span id="711">711</span>
<span id="712">712</span>
<span id="713">713</span>
<span id="714">714</span>
<span id="715">715</span>
<span id="716">716</span>
<span id="717">717</span>
<span id="718">718</span>
<span id="719">719</span>
<span id="720">720</span>
<span id="721">721</span>
<span id="722">722</span>
<span id="723">723</span>
<span id="724">724</span>
<span id="725">725</span>
<span id="726">726</span>
<span id="727">727</span>
<span id="728">728</span>
<span id="729">729</span>
<span id="730">730</span>
<span id="731">731</span>
<span id="732">732</span>
<span id="733">733</span>
<span id="734">734</span>
<span id="735">735</span>
<span id="736">736</span>
<span id="737">737</span>
<span id="738">738</span>
<span id="739">739</span>
<span id="740">740</span>
<span id="741">741</span>
<span id="742">742</span>
<span id="743">743</span>
<span id="744">744</span>
<span id="745">745</span>
<span id="746">746</span>
<span id="747">747</span>
<span id="748">748</span>
<span id="749">749</span>
<span id="750">750</span>
<span id="751">751</span>
<span id="752">752</span>
<span id="753">753</span>
<span id="754">754</span>
<span id="755">755</span>
<span id="756">756</span>
<span id="757">757</span>
<span id="758">758</span>
<span id="759">759</span>
<span id="760">760</span>
<span id="761">761</span>
<span id="762">762</span>
<span id="763">763</span>
<span id="764">764</span>
<span id="765">765</span>
<span id="766">766</span>
<span id="767">767</span>
<span id="768">768</span>
<span id="769">769</span>
<span id="770">770</span>
<span id="771">771</span>
<span id="772">772</span>
<span id="773">773</span>
<span id="774">774</span>
<span id="775">775</span>
<span id="776">776</span>
<span id="777">777</span>
<span id="778">778</span>
<span id="779">779</span>
<span id="780">780</span>
<span id="781">781</span>
<span id="782">782</span>
<span id="783">783</span>
<span id="784">784</span>
<span id="785">785</span>
<span id="786">786</span>
<span id="787">787</span>
<span id="788">788</span>
<span id="789">789</span>
<span id="790">790</span>
<span id="791">791</span>
<span id="792">792</span>
<span id="793">793</span>
<span id="794">794</span>
<span id="795">795</span>
<span id="796">796</span>
<span id="797">797</span>
<span id="798">798</span>
<span id="799">799</span>
<span id="800">800</span>
<span id="801">801</span>
<span id="802">802</span>
<span id="803">803</span>
<span id="804">804</span>
<span id="805">805</span>
<span id="806">806</span>
<span id="807">807</span>
<span id="808">808</span>
<span id="809">809</span>
<span id="810">810</span>
<span id="811">811</span>
<span id="812">812</span>
<span id="813">813</span>
<span id="814">814</span>
<span id="815">815</span>
<span id="816">816</span>
<span id="817">817</span>
<span id="818">818</span>
<span id="819">819</span>
<span id="820">820</span>
<span id="821">821</span>
</pre><pre class="rust"><code><span class="doccomment">//! Read DWARF debugging information.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * [Example Usage](#example-usage)</span>
<span class="doccomment">//! * [API Structure](#api-structure)</span>
<span class="doccomment">//! * [Using with `FallibleIterator`](#using-with-fallibleiterator)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Example Usage</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Print out all of the functions in the debuggee program:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```rust,no_run</span>
<span class="doccomment">//! # fn example() -&gt; Result&lt;(), gimli::Error&gt; {</span>
<span class="doccomment">//! # type R = gimli::EndianSlice&lt;&#39;static, gimli::LittleEndian&gt;;</span>
<span class="doccomment">//! # let get_file_section_reader = |name| -&gt; Result&lt;R, gimli::Error&gt; { unimplemented!() };</span>
<span class="doccomment">//! # let get_sup_file_section_reader = |name| -&gt; Result&lt;R, gimli::Error&gt; { unimplemented!() };</span>
<span class="doccomment">//! // Read the DWARF sections with whatever object loader you&#39;re using.</span>
<span class="doccomment">//! // These closures should return a `Reader` instance (e.g. `EndianSlice`).</span>
<span class="doccomment">//! let loader = |section: gimli::SectionId| { get_file_section_reader(section.name()) };</span>
<span class="doccomment">//! let sup_loader = |section: gimli::SectionId| { get_sup_file_section_reader(section.name()) };</span>
<span class="doccomment">//! let mut dwarf = gimli::Dwarf::load(loader)?;</span>
<span class="doccomment">//! dwarf.load_sup(sup_loader)?;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! // Iterate over all compilation units.</span>
<span class="doccomment">//! let mut iter = dwarf.units();</span>
<span class="doccomment">//! while let Some(header) = iter.next()? {</span>
<span class="doccomment">//!     // Parse the abbreviations and other information for this compilation unit.</span>
<span class="doccomment">//!     let unit = dwarf.unit(header)?;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!     // Iterate over all of this compilation unit&#39;s entries.</span>
<span class="doccomment">//!     let mut entries = unit.entries();</span>
<span class="doccomment">//!     while let Some((_, entry)) = entries.next_dfs()? {</span>
<span class="doccomment">//!         // If we find an entry for a function, print it.</span>
<span class="doccomment">//!         if entry.tag() == gimli::DW_TAG_subprogram {</span>
<span class="doccomment">//!             println!(&quot;Found a function: {:?}&quot;, entry);</span>
<span class="doccomment">//!         }</span>
<span class="doccomment">//!     }</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//! # unreachable!()</span>
<span class="doccomment">//! # }</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Full example programs:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [A simple parser](https://github.com/gimli-rs/gimli/blob/master/examples/simple.rs)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [A `dwarfdump`</span>
<span class="doccomment">//!     clone](https://github.com/gimli-rs/gimli/blob/master/examples/dwarfdump.rs)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [An `addr2line` clone](https://github.com/gimli-rs/addr2line)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`ddbug`](https://github.com/gimli-rs/ddbug), a utility giving insight into</span>
<span class="doccomment">//!     code generation by making debugging information readable</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`dwprod`](https://github.com/fitzgen/dwprod), a tiny utility to list the</span>
<span class="doccomment">//!     compilers used to create each compilation unit within a shared library or</span>
<span class="doccomment">//!     executable (via `DW_AT_producer`)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`dwarf-validate`](https://github.com/gimli-rs/gimli/blob/master/examples/dwarf-validate.rs),</span>
<span class="doccomment">//!     a program to validate the integrity of some DWARF and its references</span>
<span class="doccomment">//!     between sections and compilation units.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## API Structure</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * Basic familiarity with DWARF is assumed.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * The [`Dwarf`](./struct.Dwarf.html) type contains the commonly used DWARF</span>
<span class="doccomment">//! sections. It has methods that simplify access to debugging data that spans</span>
<span class="doccomment">//! multiple sections. Use of this type is optional, but recommended.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * Each section gets its own type. Consider these types the entry points to</span>
<span class="doccomment">//! the library:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugAbbrev`](./struct.DebugAbbrev.html): The `.debug_abbrev` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugAddr`](./struct.DebugAddr.html): The `.debug_addr` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugAranges`](./struct.DebugAranges.html): The `.debug_aranges`</span>
<span class="doccomment">//!   section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugFrame`](./struct.DebugFrame.html): The `.debug_frame` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugInfo`](./struct.DebugInfo.html): The `.debug_info` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugLine`](./struct.DebugLine.html): The `.debug_line` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugLineStr`](./struct.DebugLineStr.html): The `.debug_line_str` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugLoc`](./struct.DebugLoc.html): The `.debug_loc` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugLocLists`](./struct.DebugLocLists.html): The `.debug_loclists` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugPubNames`](./struct.DebugPubNames.html): The `.debug_pubnames`</span>
<span class="doccomment">//!   section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugPubTypes`](./struct.DebugPubTypes.html): The `.debug_pubtypes`</span>
<span class="doccomment">//!   section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugRanges`](./struct.DebugRanges.html): The `.debug_ranges` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugRngLists`](./struct.DebugRngLists.html): The `.debug_rnglists` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugStr`](./struct.DebugStr.html): The `.debug_str` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugStrOffsets`](./struct.DebugStrOffsets.html): The `.debug_str_offsets` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugTypes`](./struct.DebugTypes.html): The `.debug_types` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugCuIndex`](./struct.DebugCuIndex.html): The `.debug_cu_index` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`DebugTuIndex`](./struct.DebugTuIndex.html): The `.debug_tu_index` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`EhFrame`](./struct.EhFrame.html): The `.eh_frame` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!   * [`EhFrameHdr`](./struct.EhFrameHdr.html): The `.eh_frame_hdr` section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * Each section type exposes methods for accessing the debugging data encoded</span>
<span class="doccomment">//! in that section. For example, the [`DebugInfo`](./struct.DebugInfo.html)</span>
<span class="doccomment">//! struct has the [`units`](./struct.DebugInfo.html#method.units) method for</span>
<span class="doccomment">//! iterating over the compilation units defined within it.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * Offsets into a section are strongly typed: an offset into `.debug_info` is</span>
<span class="doccomment">//! the [`DebugInfoOffset`](./struct.DebugInfoOffset.html) type. It cannot be</span>
<span class="doccomment">//! used to index into the [`DebugLine`](./struct.DebugLine.html) type because</span>
<span class="doccomment">//! `DebugLine` represents the `.debug_line` section. There are similar types</span>
<span class="doccomment">//! for offsets relative to a compilation unit rather than a section.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ## Using with `FallibleIterator`</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The standard library&#39;s `Iterator` trait and related APIs do not play well</span>
<span class="doccomment">//! with iterators where the `next` operation is fallible. One can make the</span>
<span class="doccomment">//! `Iterator`&#39;s associated `Item` type be a `Result&lt;T, E&gt;`, however the</span>
<span class="doccomment">//! provided methods cannot gracefully handle the case when an `Err` is</span>
<span class="doccomment">//! returned.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This situation led to the</span>
<span class="doccomment">//! [`fallible-iterator`](https://crates.io/crates/fallible-iterator) crate&#39;s</span>
<span class="doccomment">//! existence. You can read more of the rationale for its existence in its</span>
<span class="doccomment">//! docs. The crate provides the helpers you have come to expect (eg `map`,</span>
<span class="doccomment">//! `filter`, etc) for iterators that can fail.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! `gimli`&#39;s many lazy parsing iterators are a perfect match for the</span>
<span class="doccomment">//! `fallible-iterator` crate&#39;s `FallibleIterator` trait because parsing is not</span>
<span class="doccomment">//! done eagerly. Parse errors later in the input might only be discovered after</span>
<span class="doccomment">//! having iterated through many items.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! To use `gimli` iterators with `FallibleIterator`, import the crate and trait</span>
<span class="doccomment">//! into your code:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! # #[cfg(feature = &quot;fallible-iterator&quot;)]</span>
<span class="doccomment">//! # fn foo() {</span>
<span class="doccomment">//! // Use the `FallibleIterator` trait so its methods are in scope!</span>
<span class="doccomment">//! use fallible_iterator::FallibleIterator;</span>
<span class="doccomment">//! use gimli::{DebugAranges, EndianSlice, LittleEndian};</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! fn find_sum_of_address_range_lengths(aranges: DebugAranges&lt;EndianSlice&lt;LittleEndian&gt;&gt;)</span>
<span class="doccomment">//!     -&gt; gimli::Result&lt;u64&gt;</span>
<span class="doccomment">//! {</span>
<span class="doccomment">//!     // `DebugAranges::headers` returns a `FallibleIterator`!</span>
<span class="doccomment">//!     aranges.headers()</span>
<span class="doccomment">//!         // `flat_map` is provided by `FallibleIterator`!</span>
<span class="doccomment">//!         .flat_map(|header| Ok(header.entries()))</span>
<span class="doccomment">//!         // `map` is provided by `FallibleIterator`!</span>
<span class="doccomment">//!         .map(|arange| Ok(arange.length()))</span>
<span class="doccomment">//!         // `fold` is provided by `FallibleIterator`!</span>
<span class="doccomment">//!         .fold(0, |sum, len| Ok(sum + len))</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//! # }</span>
<span class="doccomment">//! # fn main() {}</span>
<span class="doccomment">//! ```</span>

<span class="kw">use</span> <span class="ident">core::fmt</span>::{<span class="self">self</span>, <span class="ident">Debug</span>};
<span class="kw">use</span> <span class="ident">core::result</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident">std</span>::{<span class="ident">error</span>, <span class="ident">io</span>};

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::common</span>::{<span class="ident">Register</span>, <span class="ident">SectionId</span>};
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::constants</span>;

<span class="kw">mod</span> <span class="ident">util</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident">util</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">addr</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::addr</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">cfi</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::cfi</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">dwarf</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::dwarf</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">endian_slice</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::endian_slice</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;endian-reader&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">endian_reader</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;endian-reader&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::endian_reader</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">reader</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::reader</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">abbrev</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::abbrev</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">aranges</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::aranges</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">index</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::index</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">line</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::line</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">lists</span>;

<span class="kw">mod</span> <span class="ident">loclists</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::loclists</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">lookup</span>;

<span class="kw">mod</span> <span class="ident">op</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::op</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">pubnames</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::pubnames</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">pubtypes</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::pubtypes</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">rnglists</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::rnglists</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">str</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::str</span>::<span class="kw-2">*</span>;

<span class="doccomment">/// An offset into the current compilation or type unit.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Ord</span>, <span class="ident">PartialOrd</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">UnitOffset</span><span class="op">&lt;</span><span class="ident">T</span> <span class="op">=</span> <span class="ident">usize</span><span class="op">&gt;</span>(<span class="kw">pub</span> <span class="ident">T</span>);

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">unit</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;read&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::unit</span>::<span class="kw-2">*</span>;

<span class="kw">mod</span> <span class="ident">value</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::value</span>::<span class="kw-2">*</span>;

<span class="doccomment">/// Indicates that storage should be allocated on heap.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">StoreOnHeap</span>;

<span class="doccomment">/// `EndianBuf` has been renamed to `EndianSlice`. For ease of upgrading across</span>
<span class="doccomment">/// `gimli` versions, we export this type alias.</span>
<span class="attribute">#[<span class="ident">deprecated</span>(<span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;EndianBuf has been renamed to EndianSlice, use that instead.&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">EndianBuf</span><span class="op">&lt;</span><span class="lifetime">&#39;input</span>, <span class="ident">Endian</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">EndianSlice</span><span class="op">&lt;</span><span class="lifetime">&#39;input</span>, <span class="ident">Endian</span><span class="op">&gt;</span>;

<span class="doccomment">/// An error that occurred when parsing.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Error</span> {
    <span class="doccomment">/// An I/O error occurred while reading.</span>
    <span class="ident">Io</span>,
    <span class="doccomment">/// Found a PC relative pointer, but the section base is undefined.</span>
    <span class="ident">PcRelativePointerButSectionBaseIsUndefined</span>,
    <span class="doccomment">/// Found a `.text` relative pointer, but the `.text` base is undefined.</span>
    <span class="ident">TextRelativePointerButTextBaseIsUndefined</span>,
    <span class="doccomment">/// Found a data relative pointer, but the data base is undefined.</span>
    <span class="ident">DataRelativePointerButDataBaseIsUndefined</span>,
    <span class="doccomment">/// Found a function relative pointer in a context that does not have a</span>
    <span class="doccomment">/// function base.</span>
    <span class="ident">FuncRelativePointerInBadContext</span>,
    <span class="doccomment">/// Cannot parse a pointer with a `DW_EH_PE_omit` encoding.</span>
    <span class="ident">CannotParseOmitPointerEncoding</span>,
    <span class="doccomment">/// An error parsing an unsigned LEB128 value.</span>
    <span class="ident">BadUnsignedLeb128</span>,
    <span class="doccomment">/// An error parsing a signed LEB128 value.</span>
    <span class="ident">BadSignedLeb128</span>,
    <span class="doccomment">/// An abbreviation declared that its tag is zero, but zero is reserved for</span>
    <span class="doccomment">/// null records.</span>
    <span class="ident">AbbreviationTagZero</span>,
    <span class="doccomment">/// An attribute specification declared that its form is zero, but zero is</span>
    <span class="doccomment">/// reserved for null records.</span>
    <span class="ident">AttributeFormZero</span>,
    <span class="doccomment">/// The abbreviation&#39;s has-children byte was not one of</span>
    <span class="doccomment">/// `DW_CHILDREN_{yes,no}`.</span>
    <span class="ident">BadHasChildren</span>,
    <span class="doccomment">/// The specified length is impossible.</span>
    <span class="ident">BadLength</span>,
    <span class="doccomment">/// Found an unknown `DW_FORM_*` type.</span>
    <span class="ident">UnknownForm</span>,
    <span class="doccomment">/// Expected a zero, found something else.</span>
    <span class="ident">ExpectedZero</span>,
    <span class="doccomment">/// Found an abbreviation code that has already been used.</span>
    <span class="ident">DuplicateAbbreviationCode</span>,
    <span class="doccomment">/// Found a duplicate arange.</span>
    <span class="ident">DuplicateArange</span>,
    <span class="doccomment">/// Found an unknown reserved length value.</span>
    <span class="ident">UnknownReservedLength</span>,
    <span class="doccomment">/// Found an unknown DWARF version.</span>
    <span class="ident">UnknownVersion</span>(<span class="ident">u64</span>),
    <span class="doccomment">/// Found a record with an unknown abbreviation code.</span>
    <span class="ident">UnknownAbbreviation</span>,
    <span class="doccomment">/// Hit the end of input before it was expected.</span>
    <span class="ident">UnexpectedEof</span>(<span class="ident">ReaderOffsetId</span>),
    <span class="doccomment">/// Read a null entry before it was expected.</span>
    <span class="ident">UnexpectedNull</span>,
    <span class="doccomment">/// Found an unknown standard opcode.</span>
    <span class="ident">UnknownStandardOpcode</span>(<span class="ident">constants::DwLns</span>),
    <span class="doccomment">/// Found an unknown extended opcode.</span>
    <span class="ident">UnknownExtendedOpcode</span>(<span class="ident">constants::DwLne</span>),
    <span class="doccomment">/// The specified address size is not supported.</span>
    <span class="ident">UnsupportedAddressSize</span>(<span class="ident">u8</span>),
    <span class="doccomment">/// The specified offset size is not supported.</span>
    <span class="ident">UnsupportedOffsetSize</span>(<span class="ident">u8</span>),
    <span class="doccomment">/// The specified field size is not supported.</span>
    <span class="ident">UnsupportedFieldSize</span>(<span class="ident">u8</span>),
    <span class="doccomment">/// The minimum instruction length must not be zero.</span>
    <span class="ident">MinimumInstructionLengthZero</span>,
    <span class="doccomment">/// The maximum operations per instruction must not be zero.</span>
    <span class="ident">MaximumOperationsPerInstructionZero</span>,
    <span class="doccomment">/// The line range must not be zero.</span>
    <span class="ident">LineRangeZero</span>,
    <span class="doccomment">/// The opcode base must not be zero.</span>
    <span class="ident">OpcodeBaseZero</span>,
    <span class="doccomment">/// Found an invalid UTF-8 string.</span>
    <span class="ident">BadUtf8</span>,
    <span class="doccomment">/// Expected to find the CIE ID, but found something else.</span>
    <span class="ident">NotCieId</span>,
    <span class="doccomment">/// Expected to find a pointer to a CIE, but found the CIE ID instead.</span>
    <span class="ident">NotCiePointer</span>,
    <span class="doccomment">/// Expected to find a pointer to an FDE, but found a CIE instead.</span>
    <span class="ident">NotFdePointer</span>,
    <span class="doccomment">/// Invalid branch target for a DW_OP_bra or DW_OP_skip.</span>
    <span class="ident">BadBranchTarget</span>(<span class="ident">u64</span>),
    <span class="doccomment">/// DW_OP_push_object_address used but no address passed in.</span>
    <span class="ident">InvalidPushObjectAddress</span>,
    <span class="doccomment">/// Not enough items on the stack when evaluating an expression.</span>
    <span class="ident">NotEnoughStackItems</span>,
    <span class="doccomment">/// Too many iterations to compute the expression.</span>
    <span class="ident">TooManyIterations</span>,
    <span class="doccomment">/// An unrecognized operation was found while parsing a DWARF</span>
    <span class="doccomment">/// expression.</span>
    <span class="ident">InvalidExpression</span>(<span class="ident">constants::DwOp</span>),
    <span class="doccomment">/// An unsupported operation was found while evaluating a DWARF expression.</span>
    <span class="ident">UnsupportedEvaluation</span>,
    <span class="doccomment">/// The expression had a piece followed by an expression</span>
    <span class="doccomment">/// terminator without a piece.</span>
    <span class="ident">InvalidPiece</span>,
    <span class="doccomment">/// An expression-terminating operation was followed by something</span>
    <span class="doccomment">/// other than the end of the expression or a piece operation.</span>
    <span class="ident">InvalidExpressionTerminator</span>(<span class="ident">u64</span>),
    <span class="doccomment">/// Division or modulus by zero when evaluating an expression.</span>
    <span class="ident">DivisionByZero</span>,
    <span class="doccomment">/// An expression operation used mismatching types.</span>
    <span class="ident">TypeMismatch</span>,
    <span class="doccomment">/// An expression operation required an integral type but saw a</span>
    <span class="doccomment">/// floating point type.</span>
    <span class="ident">IntegralTypeRequired</span>,
    <span class="doccomment">/// An expression operation used types that are not supported.</span>
    <span class="ident">UnsupportedTypeOperation</span>,
    <span class="doccomment">/// The shift value in an expression must be a non-negative integer.</span>
    <span class="ident">InvalidShiftExpression</span>,
    <span class="doccomment">/// An unknown DW_CFA_* instruction.</span>
    <span class="ident">UnknownCallFrameInstruction</span>(<span class="ident">constants::DwCfa</span>),
    <span class="doccomment">/// The end of an address range was before the beginning.</span>
    <span class="ident">InvalidAddressRange</span>,
    <span class="doccomment">/// The end offset of a loc list entry was before the beginning.</span>
    <span class="ident">InvalidLocationAddressRange</span>,
    <span class="doccomment">/// Encountered a call frame instruction in a context in which it is not</span>
    <span class="doccomment">/// valid.</span>
    <span class="ident">CfiInstructionInInvalidContext</span>,
    <span class="doccomment">/// When evaluating call frame instructions, found a `DW_CFA_restore_state`</span>
    <span class="doccomment">/// stack pop instruction, but the stack was empty, and had nothing to pop.</span>
    <span class="ident">PopWithEmptyStack</span>,
    <span class="doccomment">/// Do not have unwind info for the given address.</span>
    <span class="ident">NoUnwindInfoForAddress</span>,
    <span class="doccomment">/// An offset value was larger than the maximum supported value.</span>
    <span class="ident">UnsupportedOffset</span>,
    <span class="doccomment">/// The given pointer encoding is either unknown or invalid.</span>
    <span class="ident">UnknownPointerEncoding</span>,
    <span class="doccomment">/// Did not find an entry at the given offset.</span>
    <span class="ident">NoEntryAtGivenOffset</span>,
    <span class="doccomment">/// The given offset is out of bounds.</span>
    <span class="ident">OffsetOutOfBounds</span>,
    <span class="doccomment">/// Found an unknown CFI augmentation.</span>
    <span class="ident">UnknownAugmentation</span>,
    <span class="doccomment">/// We do not support the given pointer encoding yet.</span>
    <span class="ident">UnsupportedPointerEncoding</span>,
    <span class="doccomment">/// Registers larger than `u16` are not supported.</span>
    <span class="ident">UnsupportedRegister</span>(<span class="ident">u64</span>),
    <span class="doccomment">/// The CFI program defined more register rules than we have storage for.</span>
    <span class="ident">TooManyRegisterRules</span>,
    <span class="doccomment">/// Attempted to push onto the CFI or evaluation stack, but it was already</span>
    <span class="doccomment">/// at full capacity.</span>
    <span class="ident">StackFull</span>,
    <span class="doccomment">/// The `.eh_frame_hdr` binary search table claims to be variable-length encoded,</span>
    <span class="doccomment">/// which makes binary search impossible.</span>
    <span class="ident">VariableLengthSearchTable</span>,
    <span class="doccomment">/// The `DW_UT_*` value for this unit is not supported yet.</span>
    <span class="ident">UnsupportedUnitType</span>,
    <span class="doccomment">/// Ranges using AddressIndex are not supported yet.</span>
    <span class="ident">UnsupportedAddressIndex</span>,
    <span class="doccomment">/// Nonzero segment selector sizes aren&#39;t supported yet.</span>
    <span class="ident">UnsupportedSegmentSize</span>,
    <span class="doccomment">/// A compilation unit or type unit is missing its top level DIE.</span>
    <span class="ident">MissingUnitDie</span>,
    <span class="doccomment">/// A DIE attribute used an unsupported form.</span>
    <span class="ident">UnsupportedAttributeForm</span>,
    <span class="doccomment">/// Missing DW_LNCT_path in file entry format.</span>
    <span class="ident">MissingFileEntryFormatPath</span>,
    <span class="doccomment">/// Expected an attribute value to be a string form.</span>
    <span class="ident">ExpectedStringAttributeValue</span>,
    <span class="doccomment">/// `DW_FORM_implicit_const` used in an invalid context.</span>
    <span class="ident">InvalidImplicitConst</span>,
    <span class="doccomment">/// Invalid section count in `.dwp` index.</span>
    <span class="ident">InvalidIndexSectionCount</span>,
    <span class="doccomment">/// Invalid slot count in `.dwp` index.</span>
    <span class="ident">InvalidIndexSlotCount</span>,
    <span class="doccomment">/// Invalid hash row in `.dwp` index.</span>
    <span class="ident">InvalidIndexRow</span>,
    <span class="doccomment">/// Unknown section type in `.dwp` index.</span>
    <span class="ident">UnknownIndexSection</span>,
}

<span class="kw">impl</span> <span class="ident">fmt::Display</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>) -&gt; <span class="ident">::core::result::Result</span><span class="op">&lt;</span>(), <span class="ident">fmt::Error</span><span class="op">&gt;</span> {
        <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;{}&quot;</span>, <span class="self">self</span>.<span class="ident">description</span>())
    }
}

<span class="kw">impl</span> <span class="ident">Error</span> {
    <span class="doccomment">/// A short description of the error.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">description</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="ident">str</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">Error::Io</span> =&gt; <span class="string">&quot;An I/O error occurred while reading.&quot;</span>,
            <span class="ident">Error::PcRelativePointerButSectionBaseIsUndefined</span> =&gt; {
                <span class="string">&quot;Found a PC relative pointer, but the section base is undefined.&quot;</span>
            }
            <span class="ident">Error::TextRelativePointerButTextBaseIsUndefined</span> =&gt; {
                <span class="string">&quot;Found a `.text` relative pointer, but the `.text` base is undefined.&quot;</span>
            }
            <span class="ident">Error::DataRelativePointerButDataBaseIsUndefined</span> =&gt; {
                <span class="string">&quot;Found a data relative pointer, but the data base is undefined.&quot;</span>
            }
            <span class="ident">Error::FuncRelativePointerInBadContext</span> =&gt; {
                <span class="string">&quot;Found a function relative pointer in a context that does not have a function base.&quot;</span>
            }
            <span class="ident">Error::CannotParseOmitPointerEncoding</span> =&gt; {
                <span class="string">&quot;Cannot parse a pointer with a `DW_EH_PE_omit` encoding.&quot;</span>
            }
            <span class="ident">Error::BadUnsignedLeb128</span> =&gt; <span class="string">&quot;An error parsing an unsigned LEB128 value&quot;</span>,
            <span class="ident">Error::BadSignedLeb128</span> =&gt; <span class="string">&quot;An error parsing a signed LEB128 value&quot;</span>,
            <span class="ident">Error::AbbreviationTagZero</span> =&gt; {
                <span class="string">&quot;An abbreviation declared that its tag is zero,
                 but zero is reserved for null records&quot;</span>
            }
            <span class="ident">Error::AttributeFormZero</span> =&gt; {
                <span class="string">&quot;An attribute specification declared that its form is zero,
                 but zero is reserved for null records&quot;</span>
            }
            <span class="ident">Error::BadHasChildren</span> =&gt; {
                <span class="string">&quot;The abbreviation&#39;s has-children byte was not one of
                 `DW_CHILDREN_{yes,no}`&quot;</span>
            }
            <span class="ident">Error::BadLength</span> =&gt; <span class="string">&quot;The specified length is impossible&quot;</span>,
            <span class="ident">Error::UnknownForm</span> =&gt; <span class="string">&quot;Found an unknown `DW_FORM_*` type&quot;</span>,
            <span class="ident">Error::ExpectedZero</span> =&gt; <span class="string">&quot;Expected a zero, found something else&quot;</span>,
            <span class="ident">Error::DuplicateAbbreviationCode</span> =&gt; {
                <span class="string">&quot;Found an abbreviation code that has already been used&quot;</span>
            }
            <span class="ident">Error::DuplicateArange</span> =&gt; <span class="string">&quot;Found a duplicate arange&quot;</span>,
            <span class="ident">Error::UnknownReservedLength</span> =&gt; <span class="string">&quot;Found an unknown reserved length value&quot;</span>,
            <span class="ident">Error::UnknownVersion</span>(<span class="kw">_</span>) =&gt; <span class="string">&quot;Found an unknown DWARF version&quot;</span>,
            <span class="ident">Error::UnknownAbbreviation</span> =&gt; <span class="string">&quot;Found a record with an unknown abbreviation code&quot;</span>,
            <span class="ident">Error::UnexpectedEof</span>(<span class="kw">_</span>) =&gt; <span class="string">&quot;Hit the end of input before it was expected&quot;</span>,
            <span class="ident">Error::UnexpectedNull</span> =&gt; <span class="string">&quot;Read a null entry before it was expected.&quot;</span>,
            <span class="ident">Error::UnknownStandardOpcode</span>(<span class="kw">_</span>) =&gt; <span class="string">&quot;Found an unknown standard opcode&quot;</span>,
            <span class="ident">Error::UnknownExtendedOpcode</span>(<span class="kw">_</span>) =&gt; <span class="string">&quot;Found an unknown extended opcode&quot;</span>,
            <span class="ident">Error::UnsupportedAddressSize</span>(<span class="kw">_</span>) =&gt; <span class="string">&quot;The specified address size is not supported&quot;</span>,
            <span class="ident">Error::UnsupportedOffsetSize</span>(<span class="kw">_</span>) =&gt; <span class="string">&quot;The specified offset size is not supported&quot;</span>,
            <span class="ident">Error::UnsupportedFieldSize</span>(<span class="kw">_</span>) =&gt; <span class="string">&quot;The specified field size is not supported&quot;</span>,
            <span class="ident">Error::MinimumInstructionLengthZero</span> =&gt; {
                <span class="string">&quot;The minimum instruction length must not be zero.&quot;</span>
            }
            <span class="ident">Error::MaximumOperationsPerInstructionZero</span> =&gt; {
                <span class="string">&quot;The maximum operations per instruction must not be zero.&quot;</span>
            }
            <span class="ident">Error::LineRangeZero</span> =&gt; <span class="string">&quot;The line range must not be zero.&quot;</span>,
            <span class="ident">Error::OpcodeBaseZero</span> =&gt; <span class="string">&quot;The opcode base must not be zero.&quot;</span>,
            <span class="ident">Error::BadUtf8</span> =&gt; <span class="string">&quot;Found an invalid UTF-8 string.&quot;</span>,
            <span class="ident">Error::NotCieId</span> =&gt; <span class="string">&quot;Expected to find the CIE ID, but found something else.&quot;</span>,
            <span class="ident">Error::NotCiePointer</span> =&gt; <span class="string">&quot;Expected to find a CIE pointer, but found the CIE ID instead.&quot;</span>,
            <span class="ident">Error::NotFdePointer</span> =&gt; {
                <span class="string">&quot;Expected to find an FDE pointer, but found a CIE pointer instead.&quot;</span>
            }
            <span class="ident">Error::BadBranchTarget</span>(<span class="kw">_</span>) =&gt; <span class="string">&quot;Invalid branch target in DWARF expression&quot;</span>,
            <span class="ident">Error::InvalidPushObjectAddress</span> =&gt; {
                <span class="string">&quot;DW_OP_push_object_address used but no object address given&quot;</span>
            }
            <span class="ident">Error::NotEnoughStackItems</span> =&gt; <span class="string">&quot;Not enough items on stack when evaluating expression&quot;</span>,
            <span class="ident">Error::TooManyIterations</span> =&gt; <span class="string">&quot;Too many iterations to evaluate DWARF expression&quot;</span>,
            <span class="ident">Error::InvalidExpression</span>(<span class="kw">_</span>) =&gt; <span class="string">&quot;Invalid opcode in DWARF expression&quot;</span>,
            <span class="ident">Error::UnsupportedEvaluation</span> =&gt; <span class="string">&quot;Unsupported operation when evaluating expression&quot;</span>,
            <span class="ident">Error::InvalidPiece</span> =&gt; {
                <span class="string">&quot;DWARF expression has piece followed by non-piece expression at end&quot;</span>
            }
            <span class="ident">Error::InvalidExpressionTerminator</span>(<span class="kw">_</span>) =&gt; <span class="string">&quot;Expected DW_OP_piece or DW_OP_bit_piece&quot;</span>,
            <span class="ident">Error::DivisionByZero</span> =&gt; <span class="string">&quot;Division or modulus by zero when evaluating expression&quot;</span>,
            <span class="ident">Error::TypeMismatch</span> =&gt; <span class="string">&quot;Type mismatch when evaluating expression&quot;</span>,
            <span class="ident">Error::IntegralTypeRequired</span> =&gt; <span class="string">&quot;Integral type expected when evaluating expression&quot;</span>,
            <span class="ident">Error::UnsupportedTypeOperation</span> =&gt; {
                <span class="string">&quot;An expression operation used types that are not supported&quot;</span>
            }
            <span class="ident">Error::InvalidShiftExpression</span> =&gt; {
                <span class="string">&quot;The shift value in an expression must be a non-negative integer.&quot;</span>
            }
            <span class="ident">Error::UnknownCallFrameInstruction</span>(<span class="kw">_</span>) =&gt; <span class="string">&quot;An unknown DW_CFA_* instructiion&quot;</span>,
            <span class="ident">Error::InvalidAddressRange</span> =&gt; {
                <span class="string">&quot;The end of an address range must not be before the beginning.&quot;</span>
            }
            <span class="ident">Error::InvalidLocationAddressRange</span> =&gt; {
                <span class="string">&quot;The end offset of a location list entry must not be before the beginning.&quot;</span>
            }
            <span class="ident">Error::CfiInstructionInInvalidContext</span> =&gt; {
                <span class="string">&quot;Encountered a call frame instruction in a context in which it is not valid.&quot;</span>
            }
            <span class="ident">Error::PopWithEmptyStack</span> =&gt; {
                <span class="string">&quot;When evaluating call frame instructions, found a `DW_CFA_restore_state` stack pop \
                 instruction, but the stack was empty, and had nothing to pop.&quot;</span>
            }
            <span class="ident">Error::NoUnwindInfoForAddress</span> =&gt; <span class="string">&quot;Do not have unwind info for the given address.&quot;</span>,
            <span class="ident">Error::UnsupportedOffset</span> =&gt; {
                <span class="string">&quot;An offset value was larger than the maximum supported value.&quot;</span>
            }
            <span class="ident">Error::UnknownPointerEncoding</span> =&gt; {
                <span class="string">&quot;The given pointer encoding is either unknown or invalid.&quot;</span>
            }
            <span class="ident">Error::NoEntryAtGivenOffset</span> =&gt; <span class="string">&quot;Did not find an entry at the given offset.&quot;</span>,
            <span class="ident">Error::OffsetOutOfBounds</span> =&gt; <span class="string">&quot;The given offset is out of bounds.&quot;</span>,
            <span class="ident">Error::UnknownAugmentation</span> =&gt; <span class="string">&quot;Found an unknown CFI augmentation.&quot;</span>,
            <span class="ident">Error::UnsupportedPointerEncoding</span> =&gt; {
                <span class="string">&quot;We do not support the given pointer encoding yet.&quot;</span>
            }
            <span class="ident">Error::UnsupportedRegister</span>(<span class="kw">_</span>) =&gt; <span class="string">&quot;Registers larger than `u16` are not supported.&quot;</span>,
            <span class="ident">Error::TooManyRegisterRules</span> =&gt; {
                <span class="string">&quot;The CFI program defined more register rules than we have storage for.&quot;</span>
            }
            <span class="ident">Error::StackFull</span> =&gt; {
                <span class="string">&quot;Attempted to push onto the CFI stack, but it was already at full capacity.&quot;</span>
            }
            <span class="ident">Error::VariableLengthSearchTable</span> =&gt; {
                <span class="string">&quot;The `.eh_frame_hdr` binary search table claims to be variable-length encoded, \
                 which makes binary search impossible.&quot;</span>
            }
            <span class="ident">Error::UnsupportedUnitType</span> =&gt; <span class="string">&quot;The `DW_UT_*` value for this unit is not supported yet&quot;</span>,
            <span class="ident">Error::UnsupportedAddressIndex</span> =&gt; <span class="string">&quot;Ranges involving AddressIndex are not supported yet&quot;</span>,
            <span class="ident">Error::UnsupportedSegmentSize</span> =&gt; <span class="string">&quot;Nonzero segment size not supported yet&quot;</span>,
            <span class="ident">Error::MissingUnitDie</span> =&gt; {
                <span class="string">&quot;A compilation unit or type unit is missing its top level DIE.&quot;</span>
            }
            <span class="ident">Error::UnsupportedAttributeForm</span> =&gt; <span class="string">&quot;A DIE attribute used an unsupported form.&quot;</span>,
            <span class="ident">Error::MissingFileEntryFormatPath</span> =&gt; <span class="string">&quot;Missing DW_LNCT_path in file entry format.&quot;</span>,
            <span class="ident">Error::ExpectedStringAttributeValue</span> =&gt; {
                <span class="string">&quot;Expected an attribute value to be a string form.&quot;</span>
            }
            <span class="ident">Error::InvalidImplicitConst</span> =&gt; <span class="string">&quot;DW_FORM_implicit_const used in an invalid context.&quot;</span>,
            <span class="ident">Error::InvalidIndexSectionCount</span> =&gt; <span class="string">&quot;Invalid section count in `.dwp` index.&quot;</span>,
            <span class="ident">Error::InvalidIndexSlotCount</span> =&gt; <span class="string">&quot;Invalid slot count in `.dwp` index.&quot;</span>,
            <span class="ident">Error::InvalidIndexRow</span> =&gt; <span class="string">&quot;Invalid hash row in `.dwp` index.&quot;</span>,
            <span class="ident">Error::UnknownIndexSection</span> =&gt; <span class="string">&quot;Unknown section type in `.dwp` index.&quot;</span>,
        }
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">impl</span> <span class="ident">error::Error</span> <span class="kw">for</span> <span class="ident">Error</span> {}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">impl</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">io::Error</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="kw">_</span>: <span class="ident">io::Error</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">Error::Io</span>
    }
}

<span class="doccomment">/// The result of a parse.</span>
<span class="kw">pub</span> <span class="kw">type</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">result::Result</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">Error</span><span class="op">&gt;</span>;

<span class="doccomment">/// A convenience trait for loading DWARF sections from object files.  To be</span>
<span class="doccomment">/// used like:</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// use gimli::{DebugInfo, EndianSlice, LittleEndian, Reader, Section};</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let buf = [0x00, 0x01, 0x02, 0x03];</span>
<span class="doccomment">/// let reader = EndianSlice::new(&amp;buf, LittleEndian);</span>
<span class="doccomment">/// let loader = |name| -&gt; Result&lt;_, ()&gt; { Ok(reader) };</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let debug_info: DebugInfo&lt;_&gt; = Section::load(loader).unwrap();</span>
<span class="doccomment">/// ```</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Section</span><span class="op">&lt;</span><span class="ident">R</span><span class="op">&gt;</span>: <span class="ident">From</span><span class="op">&lt;</span><span class="ident">R</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Returns the section id for this type.</span>
    <span class="kw">fn</span> <span class="ident">id</span>() -&gt; <span class="ident">SectionId</span>;

    <span class="doccomment">/// Returns the ELF section name for this type.</span>
    <span class="kw">fn</span> <span class="ident">section_name</span>() -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span> {
        <span class="ident"><span class="self">Self</span>::id</span>().<span class="ident">name</span>()
    }

    <span class="doccomment">/// Returns the ELF section name (if any) for this type when used in a dwo</span>
    <span class="doccomment">/// file.</span>
    <span class="kw">fn</span> <span class="ident">dwo_section_name</span>() -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> <span class="ident">str</span><span class="op">&gt;</span> {
        <span class="ident"><span class="self">Self</span>::id</span>().<span class="ident">dwo_name</span>()
    }

    <span class="doccomment">/// Try to load the section using the given loader function.</span>
    <span class="kw">fn</span> <span class="ident">load</span><span class="op">&lt;</span><span class="ident">F</span>, <span class="ident">E</span><span class="op">&gt;</span>(<span class="ident">f</span>: <span class="ident">F</span>) -&gt; <span class="ident">core::result::Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident">E</span><span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">F</span>: <span class="ident">FnOnce</span>(<span class="ident">SectionId</span>) -&gt; <span class="ident">core::result::Result</span><span class="op">&lt;</span><span class="ident">R</span>, <span class="ident">E</span><span class="op">&gt;</span>,
    {
        <span class="ident">f</span>(<span class="ident"><span class="self">Self</span>::id</span>()).<span class="ident">map</span>(<span class="ident">From::from</span>)
    }

    <span class="doccomment">/// Returns the `Reader` for this section.</span>
    <span class="kw">fn</span> <span class="ident">reader</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="ident">R</span>
    <span class="kw">where</span>
        <span class="ident">R</span>: <span class="ident">Reader</span>;

    <span class="doccomment">/// Returns the subrange of the section that is the contribution of</span>
    <span class="doccomment">/// a unit in a `.dwp` file.</span>
    <span class="kw">fn</span> <span class="ident">dwp_range</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">offset</span>: <span class="ident">u32</span>, <span class="ident">size</span>: <span class="ident">u32</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">R</span>: <span class="ident">Reader</span>,
    {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">data</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">reader</span>().<span class="ident">clone</span>();
        <span class="ident">data</span>.<span class="ident">skip</span>(<span class="ident">R::Offset::from_u32</span>(<span class="ident">offset</span>))<span class="question-mark">?</span>;
        <span class="ident">data</span>.<span class="ident">truncate</span>(<span class="ident">R::Offset::from_u32</span>(<span class="ident">size</span>))<span class="question-mark">?</span>;
        <span class="prelude-val">Ok</span>(<span class="ident">data</span>.<span class="ident">into</span>())
    }

    <span class="doccomment">/// Returns the `Reader` for this section.</span>
    <span class="kw">fn</span> <span class="ident">lookup_offset_id</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">id</span>: <span class="ident">ReaderOffsetId</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">SectionId</span>, <span class="ident">R::Offset</span>)<span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">R</span>: <span class="ident">Reader</span>,
    {
        <span class="self">self</span>.<span class="ident">reader</span>()
            .<span class="ident">lookup_offset_id</span>(<span class="ident">id</span>)
            .<span class="ident">map</span>(<span class="op">|</span><span class="ident">offset</span><span class="op">|</span> (<span class="ident"><span class="self">Self</span>::id</span>(), <span class="ident">offset</span>))
    }
}

<span class="kw">impl</span> <span class="ident">Register</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">from_u64</span>(<span class="ident">x</span>: <span class="ident">u64</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Register</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">y</span> <span class="op">=</span> <span class="ident">x</span> <span class="kw">as</span> <span class="ident">u16</span>;
        <span class="kw">if</span> <span class="ident">u64::from</span>(<span class="ident">y</span>) <span class="op">==</span> <span class="ident">x</span> {
            <span class="prelude-val">Ok</span>(<span class="ident">Register</span>(<span class="ident">y</span>))
        } <span class="kw">else</span> {
            <span class="prelude-val">Err</span>(<span class="ident">Error::UnsupportedRegister</span>(<span class="ident">x</span>))
        }
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;
    <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::common::Format</span>;
    <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::endianity::LittleEndian</span>;
    <span class="kw">use</span> <span class="ident">test_assembler</span>::{<span class="ident">Endian</span>, <span class="ident">Section</span>};

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_parse_initial_length_32_ok</span>() {
        <span class="kw">let</span> <span class="ident">section</span> <span class="op">=</span> <span class="ident">Section::with_endian</span>(<span class="ident">Endian::Little</span>).<span class="ident">L32</span>(<span class="number">0x7856_3412</span>);
        <span class="kw">let</span> <span class="ident">buf</span> <span class="op">=</span> <span class="ident">section</span>.<span class="ident">get_contents</span>().<span class="ident">unwrap</span>();

        <span class="kw">let</span> <span class="ident">input</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">EndianSlice::new</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>, <span class="ident">LittleEndian</span>);
        <span class="kw">match</span> <span class="ident">input</span>.<span class="ident">read_initial_length</span>() {
            <span class="prelude-val">Ok</span>((<span class="ident">length</span>, <span class="ident">format</span>)) =&gt; {
                <span class="macro">assert_eq!</span>(<span class="ident">input</span>.<span class="ident">len</span>(), <span class="number">0</span>);
                <span class="macro">assert_eq!</span>(<span class="ident">format</span>, <span class="ident">Format::Dwarf32</span>);
                <span class="macro">assert_eq!</span>(<span class="number">0x7856_3412</span>, <span class="ident">length</span>);
            }
            <span class="ident">otherwise</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;Unexpected result: {:?}&quot;</span>, <span class="ident">otherwise</span>),
        }
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_parse_initial_length_64_ok</span>() {
        <span class="kw">let</span> <span class="ident">section</span> <span class="op">=</span> <span class="ident">Section::with_endian</span>(<span class="ident">Endian::Little</span>)
            <span class="comment">// Dwarf_64_INITIAL_UNIT_LENGTH</span>
            .<span class="ident">L32</span>(<span class="number">0xffff_ffff</span>)
            <span class="comment">// Actual length</span>
            .<span class="ident">L64</span>(<span class="number">0xffde_bc9a_7856_3412</span>);
        <span class="kw">let</span> <span class="ident">buf</span> <span class="op">=</span> <span class="ident">section</span>.<span class="ident">get_contents</span>().<span class="ident">unwrap</span>();
        <span class="kw">let</span> <span class="ident">input</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">EndianSlice::new</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>, <span class="ident">LittleEndian</span>);

        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;64&quot;</span>)]</span>
        <span class="kw">match</span> <span class="ident">input</span>.<span class="ident">read_initial_length</span>() {
            <span class="prelude-val">Ok</span>((<span class="ident">length</span>, <span class="ident">format</span>)) =&gt; {
                <span class="macro">assert_eq!</span>(<span class="ident">input</span>.<span class="ident">len</span>(), <span class="number">0</span>);
                <span class="macro">assert_eq!</span>(<span class="ident">format</span>, <span class="ident">Format::Dwarf64</span>);
                <span class="macro">assert_eq!</span>(<span class="number">0xffde_bc9a_7856_3412</span>, <span class="ident">length</span>);
            }
            <span class="ident">otherwise</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;Unexpected result: {:?}&quot;</span>, <span class="ident">otherwise</span>),
        }

        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;32&quot;</span>)]</span>
        <span class="kw">match</span> <span class="ident">input</span>.<span class="ident">read_initial_length</span>() {
            <span class="prelude-val">Err</span>(<span class="ident">Error::UnsupportedOffset</span>) =&gt; {}
            <span class="ident">otherwise</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;Unexpected result: {:?}&quot;</span>, <span class="ident">otherwise</span>),
        };
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_parse_initial_length_unknown_reserved_value</span>() {
        <span class="kw">let</span> <span class="ident">section</span> <span class="op">=</span> <span class="ident">Section::with_endian</span>(<span class="ident">Endian::Little</span>).<span class="ident">L32</span>(<span class="number">0xffff_fffe</span>);
        <span class="kw">let</span> <span class="ident">buf</span> <span class="op">=</span> <span class="ident">section</span>.<span class="ident">get_contents</span>().<span class="ident">unwrap</span>();

        <span class="kw">let</span> <span class="ident">input</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">EndianSlice::new</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>, <span class="ident">LittleEndian</span>);
        <span class="kw">match</span> <span class="ident">input</span>.<span class="ident">read_initial_length</span>() {
            <span class="prelude-val">Err</span>(<span class="ident">Error::UnknownReservedLength</span>) =&gt; <span class="macro">assert!</span>(<span class="bool-val">true</span>),
            <span class="ident">otherwise</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;Unexpected result: {:?}&quot;</span>, <span class="ident">otherwise</span>),
        };
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_parse_initial_length_incomplete</span>() {
        <span class="kw">let</span> <span class="ident">buf</span> <span class="op">=</span> [<span class="number">0xff</span>, <span class="number">0xff</span>, <span class="number">0xff</span>]; <span class="comment">// Need at least 4 bytes.</span>

        <span class="kw">let</span> <span class="ident">input</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">EndianSlice::new</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>, <span class="ident">LittleEndian</span>);
        <span class="kw">match</span> <span class="ident">input</span>.<span class="ident">read_initial_length</span>() {
            <span class="prelude-val">Err</span>(<span class="ident">Error::UnexpectedEof</span>(<span class="kw">_</span>)) =&gt; <span class="macro">assert!</span>(<span class="bool-val">true</span>),
            <span class="ident">otherwise</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;Unexpected result: {:?}&quot;</span>, <span class="ident">otherwise</span>),
        };
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_parse_initial_length_64_incomplete</span>() {
        <span class="kw">let</span> <span class="ident">section</span> <span class="op">=</span> <span class="ident">Section::with_endian</span>(<span class="ident">Endian::Little</span>)
            <span class="comment">// Dwarf_64_INITIAL_UNIT_LENGTH</span>
            .<span class="ident">L32</span>(<span class="number">0xffff_ffff</span>)
            <span class="comment">// Actual length is not long enough.</span>
            .<span class="ident">L32</span>(<span class="number">0x7856_3412</span>);
        <span class="kw">let</span> <span class="ident">buf</span> <span class="op">=</span> <span class="ident">section</span>.<span class="ident">get_contents</span>().<span class="ident">unwrap</span>();

        <span class="kw">let</span> <span class="ident">input</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">EndianSlice::new</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>, <span class="ident">LittleEndian</span>);
        <span class="kw">match</span> <span class="ident">input</span>.<span class="ident">read_initial_length</span>() {
            <span class="prelude-val">Err</span>(<span class="ident">Error::UnexpectedEof</span>(<span class="kw">_</span>)) =&gt; <span class="macro">assert!</span>(<span class="bool-val">true</span>),
            <span class="ident">otherwise</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;Unexpected result: {:?}&quot;</span>, <span class="ident">otherwise</span>),
        };
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_parse_offset_32</span>() {
        <span class="kw">let</span> <span class="ident">section</span> <span class="op">=</span> <span class="ident">Section::with_endian</span>(<span class="ident">Endian::Little</span>).<span class="ident">L32</span>(<span class="number">0x0123_4567</span>);
        <span class="kw">let</span> <span class="ident">buf</span> <span class="op">=</span> <span class="ident">section</span>.<span class="ident">get_contents</span>().<span class="ident">unwrap</span>();

        <span class="kw">let</span> <span class="ident">input</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">EndianSlice::new</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>, <span class="ident">LittleEndian</span>);
        <span class="kw">match</span> <span class="ident">input</span>.<span class="ident">read_offset</span>(<span class="ident">Format::Dwarf32</span>) {
            <span class="prelude-val">Ok</span>(<span class="ident">val</span>) =&gt; {
                <span class="macro">assert_eq!</span>(<span class="ident">input</span>.<span class="ident">len</span>(), <span class="number">0</span>);
                <span class="macro">assert_eq!</span>(<span class="ident">val</span>, <span class="number">0x0123_4567</span>);
            }
            <span class="ident">otherwise</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;Unexpected result: {:?}&quot;</span>, <span class="ident">otherwise</span>),
        };
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">test_parse_offset_64_small</span>() {
        <span class="kw">let</span> <span class="ident">section</span> <span class="op">=</span> <span class="ident">Section::with_endian</span>(<span class="ident">Endian::Little</span>).<span class="ident">L64</span>(<span class="number">0x0123_4567</span>);
        <span class="kw">let</span> <span class="ident">buf</span> <span class="op">=</span> <span class="ident">section</span>.<span class="ident">get_contents</span>().<span class="ident">unwrap</span>();

        <span class="kw">let</span> <span class="ident">input</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">EndianSlice::new</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>, <span class="ident">LittleEndian</span>);
        <span class="kw">match</span> <span class="ident">input</span>.<span class="ident">read_offset</span>(<span class="ident">Format::Dwarf64</span>) {
            <span class="prelude-val">Ok</span>(<span class="ident">val</span>) =&gt; {
                <span class="macro">assert_eq!</span>(<span class="ident">input</span>.<span class="ident">len</span>(), <span class="number">0</span>);
                <span class="macro">assert_eq!</span>(<span class="ident">val</span>, <span class="number">0x0123_4567</span>);
            }
            <span class="ident">otherwise</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;Unexpected result: {:?}&quot;</span>, <span class="ident">otherwise</span>),
        };
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;64&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">test_parse_offset_64_large</span>() {
        <span class="kw">let</span> <span class="ident">section</span> <span class="op">=</span> <span class="ident">Section::with_endian</span>(<span class="ident">Endian::Little</span>).<span class="ident">L64</span>(<span class="number">0x0123_4567_89ab_cdef</span>);
        <span class="kw">let</span> <span class="ident">buf</span> <span class="op">=</span> <span class="ident">section</span>.<span class="ident">get_contents</span>().<span class="ident">unwrap</span>();

        <span class="kw">let</span> <span class="ident">input</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">EndianSlice::new</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>, <span class="ident">LittleEndian</span>);
        <span class="kw">match</span> <span class="ident">input</span>.<span class="ident">read_offset</span>(<span class="ident">Format::Dwarf64</span>) {
            <span class="prelude-val">Ok</span>(<span class="ident">val</span>) =&gt; {
                <span class="macro">assert_eq!</span>(<span class="ident">input</span>.<span class="ident">len</span>(), <span class="number">0</span>);
                <span class="macro">assert_eq!</span>(<span class="ident">val</span>, <span class="number">0x0123_4567_89ab_cdef</span>);
            }
            <span class="ident">otherwise</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;Unexpected result: {:?}&quot;</span>, <span class="ident">otherwise</span>),
        };
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;32&quot;</span>)]</span>
    <span class="kw">fn</span> <span class="ident">test_parse_offset_64_large</span>() {
        <span class="kw">let</span> <span class="ident">section</span> <span class="op">=</span> <span class="ident">Section::with_endian</span>(<span class="ident">Endian::Little</span>).<span class="ident">L64</span>(<span class="number">0x0123_4567_89ab_cdef</span>);
        <span class="kw">let</span> <span class="ident">buf</span> <span class="op">=</span> <span class="ident">section</span>.<span class="ident">get_contents</span>().<span class="ident">unwrap</span>();

        <span class="kw">let</span> <span class="ident">input</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">EndianSlice::new</span>(<span class="kw-2">&amp;</span><span class="ident">buf</span>, <span class="ident">LittleEndian</span>);
        <span class="kw">match</span> <span class="ident">input</span>.<span class="ident">read_offset</span>(<span class="ident">Format::Dwarf64</span>) {
            <span class="prelude-val">Err</span>(<span class="ident">Error::UnsupportedOffset</span>) =&gt; <span class="macro">assert!</span>(<span class="bool-val">true</span>),
            <span class="ident">otherwise</span> =&gt; <span class="macro">panic!</span>(<span class="string">&quot;Unexpected result: {:?}&quot;</span>, <span class="ident">otherwise</span>),
        };
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="gimli" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>